source("time.r")

test.name <- "tst-substr.get"

f <- test.cmp (function (n, a, start, stop)
{ for (i in 1:n) x <- substr(a,start,stop)
  x
})

sys.time(r <- f(1000000,"abcdefg",2,6))
print(r)

longa <- paste(rep("a",2000),collapse="",sep="")

sys.time(r <- f(1000000,longa,2,6))
print(r)

sys.time(r <- f(200000,longa,2,1900))

test.name <- "tst-substr.set"

g <- test.cmp (function (n, a, start, stop, v)
{ for (i in 1:n) substr(a,start,stop) <- v
  a
})

sys.time(r <- g(1000000,"abcdefg",2,6,"uvwxy"))
print(r)

longa <- paste(rep("a",20000),collapse="",sep="")

sys.time(r <- g(50000,longa,2,6,"uvwxy"))

longb <- paste(rep("b",9000),collapse="",sep="")

sys.time(r <- g(50000,longa,2,9001,longb))
