source("time.r")

dyn.load(paste("tst-dotCall",.Platform$dynlib.ext,sep=""))

 
test.name <- "tst-dotCall"

f <- test.cmp (function () 
{ v <- c(10,2)
  for (i in 1:1000000) R <- .Call("tst_dotCall1",1.1,v) 
  R
})

sys.time(R<-f())
print(R)

sym <- getNativeSymbolInfo("tst_dotCall1")

f <- test.cmp (function () 
{ v <- c(10,2)
  for (i in 1:1000000) R <- .Call(sym,1.1,v) 
  R
})

sys.time(R<-f())
print(R)

addr <- getNativeSymbolInfo("tst_dotCall1")$address

f <- test.cmp (function () 
{ v <- c(10,2)
  for (i in 1:1000000) R <- .Call(addr,1.1,v) 
  R
})

sys.time(R<-f())
print(R)
